<?php
function FnSaveDataLocation($result, $mName,$fn='location.csv')
{
    global $cookie_uniqID_vl, $no_access_vl;
    // Ghi lại tất cả các thông tin sau khi tính toán
    $mfolder = "data/";
    if (!file_exists($mfolder)) {
        mkdir($mfolder, 0777);
    }
    $filename = $mfolder . $fn;
    if (!file_exists($filename)) {
        $out = fopen($filename, "w");
        fprintf($out, chr(0xef) . chr(0xbb) . chr(0xbf));
        fputcsv($out, array_merge(["Timestamp"],$mName, ["cookie_uniqID_vl","no_access_vl"])); 
        fclose($out);
    }
    $out = fopen($filename, "a");
    fprintf($out, date("Y/m/d-H:i:s") . ",");
    fputcsv($out, array_merge($result, [$cookie_uniqID_vl, $no_access_vl]));
    fclose($out);
}

function FnSaveData($result, $mName)
{
    global $cookie_uniqID_vl, $no_access_vl;
    // Ghi lại tất cả các thông tin sau khi tính toán
    $mfolder = "data/";
    if (!file_exists($mfolder)) {
        mkdir($mfolder, 0777);
    }
    $filename = $mfolder . "danhsach.csv";
    if (!file_exists($filename)) {
        $out = fopen($filename, "w");
        fprintf($out, chr(0xef) . chr(0xbb) . chr(0xbf));
        fputcsv($out, array_merge(["Timestamp"],$mName, ["cookie_uniqID_vl","no_access_vl"])); 
        fclose($out);
    }
    $out = fopen($filename, "a");
    fprintf($out, date("Y/m/d-H:i:s") . ",");
    fputcsv($out, array_merge($result, [$cookie_uniqID_vl, $no_access_vl]));
    fclose($out);
}
// Functions list:------------------------------------------
function vn_str_filter($str)
{
    $unicode = [
        "a" => "á|à|ả|ã|ạ|ă|ắ|ặ|ằ|ẳ|ẵ|â|ấ|ầ|ẩ|ẫ|ậ",
        "d" => "đ",
        "e" => "é|è|ẻ|ẽ|ẹ|ê|ế|ề|ể|ễ|ệ",
        "i" => "í|ì|ỉ|ĩ|ị",
        "o" => "ó|ò|ỏ|õ|ọ|ô|ố|ồ|ổ|ỗ|ộ|ơ|ớ|ờ|ở|ỡ|ợ",
        "u" => "ú|ù|ủ|ũ|ụ|ư|ứ|ừ|ử|ữ|ự",
        "y" => "ý|ỳ|ỷ|ỹ|ỵ",
        "A" => "Á|À|Ả|Ã|Ạ|Ă|Ắ|Ặ|Ằ|Ẳ|Ẵ|Â|Ấ|Ầ|Ẩ|Ẫ|Ậ",
        "D" => "Đ",
        "E" => "É|È|Ẻ|Ẽ|Ẹ|Ê|Ế|Ề|Ể|Ễ|Ệ",
        "I" => "Í|Ì|Ỉ|Ĩ|Ị",
        "O" => "Ó|Ò|Ỏ|Õ|Ọ|Ô|Ố|Ồ|Ổ|Ỗ|Ộ|Ơ|Ớ|Ờ|Ở|Ỡ|Ợ",
        "U" => "Ú|Ù|Ủ|Ũ|Ụ|Ư|Ứ|Ừ|Ử|Ữ|Ự",
        "Y" => "Ý|Ỳ|Ỷ|Ỹ|Ỵ",
    ];
    foreach ($unicode as $nonUnicode => $uni) {
        $str = preg_replace("/($uni)/i", $nonUnicode, $str);
    }
    return $str;
}
$data = [
    "0" => 0,
    "1" => 1,
    "2" => 2,
    "3" => 3,
    "4" => 4,
    "5" => 5,
    "6" => 6,
    "7" => 7,
    "8" => 8,
    "9" => 9,    
    "A" => 1,
    "B" => 2,
    "C" => 3,
    "D" => 4,
    "E" => 5,
    "F" => 6,
    "G" => 7,
    "H" => 8,
    "I" => 9,
    "J" => 1,
    "K" => 2,
    "L" => 3,
    "M" => 4,
    "N" => 5,
    "O" => 6,
    "P" => 7,
    "Q" => 8,
    "R" => 9,
    "S" => 1,
    "T" => 2,
    "U" => 3,
    "V" => 4,
    "W" => 5,
    "X" => 6,
    "Y" => 7,
    "Z" => 8,
    " " => " ",
];
$TenNguyenAm = [
    "A" => 1,
    "U" => 3,
    "E" => 5,
    "W" => 5,
    "O" => 6,
    "I" => 9,
    "Y" => 7,
    "_" => " ",
    " " => " ",
];
$TenPhuAm = [
    "J" => 1,
    "S" => 1,
    "K" => 2,
    "B" => 2,
    "T" => 2,
    "C" => 3,
    "L" => 3,
    "M" => 4,
    "D" => 4,
    "V" => 4,
    "N" => 5,
    "W" => 5,
    "F" => 6,
    "X" => 6,
    "P" => 7,
    "G" => 7,
    "Y" => 7,
    "Q" => 8,
    "H" => 8,
    "Z" => 9,
    "R" => 9,
    "_" => " ",
    " " => " ",
];
// End Functions list:------------------------------------------
function GetNumberFromString($ns, $Nmax = 9,$NoSpecialNum=false)
{
    // SUM, str: số tổng, string diễn giải
    /*  input:
    ns: ngày sinh, dạng ngày/tháng/năm: dd/mm/yyyy
    output:
    $ns : Tổng cuối cùng của các số trong ns
    $str: xâu chứa các phép tính diễn giải:
    VD:  0+2+1+1+1+9+8+1=23<br>2+3=5
    */
    $str = "$ns=";
    $NumB = 0;
    $digits = (int) preg_replace("/[^0-9.]+/", "", $ns);
    $SoDacbiet=[11,22,33];
    if($NoSpecialNum){$SoDacbiet=[];}
     
    if ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {
        while ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {
            $digits = "" . $digits;
            $NumB = 0;
            for ($k = 0; $k < strlen($digits); $k++) {
                $NumB += (int) $digits[$k];
                $str .= $digits[$k] . "+"; // 0+2+1+1+1+9+8+1=23<br>2+3=5
            }
            $str = substr($str, 0, strlen($str) - 1) . "=" . $NumB . "<br>";
            $digits = (int) $NumB; //5
            // echo $str."<br>";
        }
    } else {
        $str = "" . $ns . "<br>";
        $NumB = (int) $ns;
    }
    $str = substr($str, 0, strlen($str) - 4);
    // echo "<h2> Số đường đời: ".$NumB."</h2>".$str;
    return [$NumB, $str];
}

function GetNumberFromString_Cach2($Ngaysinh, $Thangsinh, $Namsinh)
{
    /*
    output:
    $num : Tổng cuối cùng của các số trong ns
    $str: xâu chứa các phép tính diễn giải:
    VD:  0+2+1+1+1+9+8+1=23<br>2+3=5
    */
    $str ="<b>Cách tính (cộng dọc) </b><br> Ngày tháng năm sinh=" .$Ngaysinh ."/" .$Thangsinh ."/" .$Namsinh ."<br>";
    // $digits = (int)preg_replace('/[^0-9.]+/', '', $Ngaysinh.$Thangsinh.$Namsinh);
    $v1 = GetNumberFromString($Ngaysinh);
    $v2 = GetNumberFromString($Thangsinh);
    $v3 = GetNumberFromString($Namsinh);

    $num = $v1[0] + $v2[0] + $v3[0];
    $str .= "Ngày:" . $v1[1] . "<br>Tháng:" . $v2[1] . "<br>Năm:" . str_replace("<br>", "=>", $v3[1]) . "<br>";
    $v4 = GetNumberFromString($num);
    $num = $v4[0];
    $str .= $v1[0] . "+" . $v2[0] . "+" . $v3[0] . "====<b>" . $num . "</b>";
    return [$num, $str];
}
function getNameBasic($NameVal, $data, $sothieu = false)
    {
        /* input:
         *      NameVal: name in string
         * output:
         *      $tenstr:  Tên dạng xâu ký tự
         *      $tenNum:  Tên dạng số
         *      $Nstr[0]: Số tổng các số
         *      $Nstr[1:  Xâu diễn giải +
         */
        $tenstr = vn_str_filter($NameVal);
        $tenstr = preg_replace("/[^0-9a-zA-Z]+/", "", $tenstr);
        $tenstr = strtoupper($tenstr);
        $ten = "";
        for ($k = 0; $k < strlen($tenstr); $k++) {
            $ten .= $data[$tenstr[$k]];
        }
        $tenNum = $ten;
        $Nstr = GetNumberFromString($ten);
        if ($sothieu) {
            $fullSo = "123456789";
            $soInput = explode("=", $ten)[0];
            // echo $soInput."<br>";
            for ($k = 0; $k < 10; $k++) {
                // echo $k.":".strpos($soInput, "".$k)."<br>";
                if (strpos($soInput, "" . $k) !== false) {
                    $fullSo = str_replace($k, "", $fullSo);
                }
            }
            return [$fullSo];
        }
        return [$tenstr, $tenNum, $Nstr[0], $Nstr[1]];
    }
function fnSum_number_Fullname_vertical($fullname,$data){
        $tenstr = vn_str_filter($fullname);
        $tenstr = strtoupper($tenstr);
        $tenstr = preg_replace("/[^0-9a-zA-Z ]+/", "", $tenstr);        
        $arHoTen=explode(" ", $tenstr);
        $SumStr=array();
        foreach($arHoTen as $word){
            $NumTen = "";
            for ($k = 0; $k < strlen($word); $k++) {
                $NumTen .= $data[$word[$k]];
            }
            $Nstr = GetNumberFromString($NumTen);
            array_push($SumStr,[$word, $NumTen,$Nstr[0], $Nstr[1]]) ;
        }
        // var_dump($SumStr);
            // array(3) {
            //       [0]=>  array(4) {
            //         [0]=>    string(6) "NGUYEN"
            //         [1]=>    string(6) "573755"
            //         [2]=>    int(5)
            //         [3]=>    string(30) "573755=5+7+3+7+5+5=32<br>3+2=5"
            //       }
            //       [1]=>  array(4) {
            //         [0]=>    string(4) "TUAN"
            //         [1]=>    string(4) "2315"
            //         [2]=>    int(11)
            //         [3]=>    string(15) "2315=2+3+1+5=11"
            //       }
            //       [2]=>  array(4) {
            //         [0]=>    string(3) "ANH"
            //         [1]=>    string(3) "158"
            //         [2]=>    int(5)
            //         [3]=>    string(21) "158=1+5+8=14<br>1+4=5"
            //       }
            //     }
        $tenNum_detail='';
        $tenInt=0;
        $tenStrSum='';
        $tenIntstr='';
        foreach($SumStr as $aW){
            $tenNum_detail.=$aW[1]." ";
            $tenInt+=$aW[2];
            $tenIntstr.=$aW[2].'+';
            $tenStrSum.=$aW[0].': '.str_replace ('<br>','=>',$aW[3]).'<br/>';
        }
        $tenIntstr = substr($tenIntstr, 0, strlen($tenIntstr) - 1) . "=" . $tenInt . "<br>";
        // var_dump($tenstr);
        // var_dump($tenNum_detail);
        // var_dump($tenInt);
        // var_dump($tenIntstr);
        // var_dump($tenStrSum);
        $tensumFinal = GetNumberFromString($tenInt);
        // var_dump($tensumFinal);
        $tenStrSum.=$tenIntstr.'===>'.$tensumFinal[1];
        $ret=[$tenstr, $tenNum_detail, $tensumFinal[0], $tenStrSum];
        // return ([0,0,0,0]);
        // var_dump($ret);
        // die();
        return $ret;
}
// $fullname="Nguyễn Tuấn Anh";
// $KQ2_5=fnSum_number_Fullname_vertical($fullname,$data);
// echo $KQ2_5[0].'<br>';
// echo $KQ2_5[1].'<br>';
// echo $KQ2_5[2].'<br>';
// echo $KQ2_5[3].'<br>';

// // var_dump($KQ2_5);

// die();

function getNguyenAm_PhuAm($NameVal, $data, $TenPhuAm, $TenNguyenAm, $NA_PA)
{
    $hoten = vn_str_filter($NameVal);
    $hoten = strtoupper($hoten);
    // Xét nguyên âm, phụ âm sẽ tính dựa vào nguyên âm
    $nguyenAm = "";
    $Phu___Am = "";
    // Y đứng cạnh nguyên âm thì nó là phụ âm, còn lại là nguyên âm
    for ($i = 0; $i < strlen($hoten); $i++) {
        $ch = $hoten[$i];
        // var_dump($ch);
        // var_dump (array_key_exists($ch, $TenNguyenAm));
        if ($ch == " ") {
            $nguyenAm .= " ";
            $Phu___Am .= " ";
            continue;
        }
        if ($ch == "Y") {
            $PA = 0;
            for ($k = 0; $k < strlen($hoten); $k++) {
                if (
                    array_key_exists($hoten[$k], $TenNguyenAm) &&
                    ($k == $i - 1 || $k == $i + 1)
                ) {
                    $PA++;
                }
            }
            if ($PA > 0) {
                //Phụ âm
                $Phu___Am .= "Y";
                $nguyenAm .= "_";
            } else {
                //nguyên âm
                $Phu___Am .= "_";
                $nguyenAm .= "Y";
            }
        } else {
            // Nếu là chữ bthuong:
            if (array_key_exists($ch, $TenNguyenAm)) {
                $Phu___Am .= "_";
                $nguyenAm .= $ch;
            } else {
                $Phu___Am .= $ch;
                $nguyenAm .= "_";
            }
        }
    }
    // var_dump($Phu___Am);
    // var_dump($nguyenAm);
    $ten = "";
    $ten_so = "";

    if ($NA_PA == "nguyenAm") {
        for ($k = 0; $k < strlen($nguyenAm); $k++) {
            if ($TenNguyenAm[$nguyenAm[$k]] != " ") {
                $ten .= $TenNguyenAm[$nguyenAm[$k]];
                $ten_so .= $TenNguyenAm[$nguyenAm[$k]];
            } else {
                $ten_so .= $nguyenAm[$k];
            }
        }
        // var_dump("Ho ten:Nguyen Am:gtri: $hoten:$nguyenAm:$ten");
        $KQ = GetNumberFromString($ten_so);
        // var_dump($KQ);
        //     $("#KhatTam").html("Con số Linh hồn/khát tâm/tâm hồn: <font face = \"Courier New\" > "+nsten+"<br>"+hoten+"=><br>"+nguyenAm+'<br>'+ten_so+"<br>"+str1+"</font>");
        //     $("#KhatTam-"+nsten).show();
        return [$nguyenAm, $KQ[0], $KQ[1]];
    } else {
        for ($k = 0; $k < strlen($Phu___Am); $k++) {
            if ($TenPhuAm[$Phu___Am[$k]] != " ") {
                $ten .= $TenPhuAm[$Phu___Am[$k]];
                $ten_so .= $TenPhuAm[$Phu___Am[$k]];
            } else {
                $ten_so .= $Phu___Am[$k];
            }
        }
        // var_dump("Ho ten:Phu    Am:gtri: $hoten:$Phu___Am:$ten");
        $KQ = GetNumberFromString($ten_so);
        //       $("#NhanCach").html("Con số nhân cách: <font face = \"Courier New\"> "+nsten+"<br>"+hoten+"=><br>"+Phu___Am+'<br>'+ten_so+"<br>"+str1+"</font>");
        //       $("#nhanCach-"+nsten).show();
        return [$Phu___Am, $KQ[0], $KQ[1]];
    }
}
?>